#!/usr/bin/python
# Python 3 required
# (C) 2023 xDevs.com
import sys
#import Gpib
import vxi11
import time
import numpy as np

log_name = "../teckit/dcl_10v_kei2002rkf_nplc20_hulk1_3458abc_nplc20_soak10s.dsv"

#fluke = Gpib.Gpib(0, 1, timeout=30) 
fluke = vxi11.Instrument("192.168.1.10", "gpib0,1") # Fluke 5720A, GPIB Address = 1
fluke.timeout = 30
fluke.clear()
fluke.write("*IDN?")
print ("Source detected = %s" % fluke.read())

dmm = vxi11.Instrument("192.168.1.12", "gpib0,3") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 30
dmm.write("ID?")
print "REF DMM detected = %s" % dmm.read()

dmm5 = vxi11.Instrument("192.168.1.10", "gpib0,7") # K2002, GPIB Address = 6
dmm5.timeout = 30
dmm5.write("*IDN?")
print "DUT detected = %s" % dmm5.read()

fluke.write("STBY")
fluke.write("RANGELCK OFF")
fluke.write("OUT 10 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("EXTSENSE OFF")
fluke.write("EXTGUARD OFF")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD OFF")
fluke.write("OPER")
time.sleep(3)
print ("SRC configured")

dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV 10")
dmm.write("NPLC 20")
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "REF DMM configured, starting ACAL"

dmm5.write("*RST")
dmm5.write(":INIT:CONT OFF")
dmm5.write(":SYST:PRES")
dmm5.write(":FORM:ELEM READ")
dmm4.write(":SYST:AZER:STAT ON")
dmm5.write(":ABOR")
dmm5.write(":SENS:FUNC 'VOLT:DC'")
dmm5.write(":SENS:VOLT:DC:RANG 10")
dmm5.write(":SENS:VOLT:DC:NPLC 20")
dmm5.write(":SENS:VOLT:DC:AVER:STAT OFF")
dmm5.write(":SENS:VOLT:DC:DIG 9")
print ("DUT configured")

dmm.write("ACAL DCV")
time.sleep(147) # Wait for ACAL to finish
print ("ACAL DCV is completed")

dmm.write("TARM SGL")
dmm.read()
dmm.write("MATH NULL")

with open(log_name, 'a') as dile:
    dile.write ("date;source;duta;dutb;dutc;dutd;dutf;sdev;sdev2;sdev3;sdev4;sdev5;temp;temp2;temp3;temp4\r\n")
dile.close()

vcnt = 0 # temporary counter
print ("Log into %s started" % log_name)

fluke.write("OUT 10V;*CLS;OPER")
fluke.write("OPER")
time.sleep(30)

for i in range(-110,110,1):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    median5 = 0.0
    sdev5 = 0.0
    array5 = []
    set_value = (float(i) / 10)
    fluke.write("OUT %.7f;*CLS;OPER" % set_value)
    fluke.write("OPER")
    time.sleep(10)
    for ix in range (0,12): #take more samples
        dmm.write("TARM SGL")
        #dmm2.write("TARM SGL")
        #dmm3.write("TARM SGL")
        #dmm4.write("TARM SGL")
        dmm5.write("READ?") #*TRG;GET;RDG?")
        val = float(dmm.read())
        val2 = 0#float(dmm2.read())
        val3 = 0#float(dmm3.read())
        val4 = 0#float(dmm4.read())
        val5 = float(dmm5.read())
        array.extend([val])
        array2.extend([val2])
        array3.extend([val3])
        array4.extend([val4])
        array5.extend([val5])
        if abs(set_value) >= 0.05:
            print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6) ))
        if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
            print ("Smoke escaped, check connections")
            fluke.write("OUT 0 V")
            fluke.write("STBY")
            quit()
    sdev = np.std(array[-3:])
    sdev2 = np.std(array2[-3:])
    sdev3 = np.std(array3[-3:])
    sdev4 = np.std(array4[-3:])
    sdev5 = np.std(array5[-3:])
    median = np.median(array[-3:])
    median2 = np.median(array2[-3:])
    median4 = np.median(array4[-3:])
    median3 = np.median(array3[-3:])
    median5 = np.median(array5[-3:])
    if abs(float(i) / 10) >= 0.0005:
        dev1 = ((median / set_value - 1) * 1e6)
        dev2 = ((median2 /set_value - 1) * 1e6)
        dev3 = ((median3 /set_value - 1) * 1e6)
        dev4 = ((median4 /set_value - 1) * 1e6)
        print("\033[32;1mSRC %.5f \033[33;1mA %.9f, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9f, sdev5 = %.3f uV, med5 = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
    #dmm.write("TEMP?")
    #dmm2.write("TEMP?")
    #dmm3.write("TEMP?")
    #dmm4.write("TEMP?")
    temp = 0#float(dmm.read())
    temp2 = 0#float(dmm2.read())
    temp3 = 0#float(dmm3.read())
    temp4 = 0#float(dmm4.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.5f;%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, median5, sdev, sdev2, sdev3, sdev4, sdev5, temp, temp2, temp3, temp4)))
    dile.close()

# Reset all instruments to safety
fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm5.write("*RST")
